#ifndef _ASSERT_H_
#define _ASSERT_H_

int kputs(char *s);

#define STRING(n) STRING2(n)
#define STRING2(n) #n

#ifdef NDEBUG

#define assert(n)

#else

#define assert(n) \
do { \
	if (!(n)) \
		panic(__FILE__":"STRING(__LINE__)": " \
		"Assertion `"#n"' failed.\n" \
		"Aborted\n"); \
} while (0)

#endif

#endif
