/*
;
;       Small C+ Library Functions
;
;       Memory Functions
;
;       The routines in this directory are a little kludgey to say the
;       least, but at least they give you a heap from BBC BASIC
;
;       These routines were found on an MSX homepage from the net
;
;       Added to Z88dk archive 1/3/99
;
; char *malloc(int bytes);
;
;
; $Id: malloc.asm,v 1.2 2001/04/18 14:59:40 stefano Exp $
;
*/

/* FIXME: massage this file please */
/* make a struct with self-pointer "next" and size_t "size".
 * also, add process owner information (links/whatever) to the struct.
 */

void *malloc(size_t size)
{
	if (!size)
		return NULL;
	
	size += 4;	/* add headersize */
	
	/* if size overflows, return 0 */
	
	p = HeapLast;
	
	for (i = HeapBlocks; i; --i) {
		prev = p;
		p = p->next;
		if (p->size >= size) {
			HeapLast = p;
			if (p->size == size) {
				prev->next = p->next;
				--HeapBlocks;
			} else {
				p->size -= size;
				p+=p->size;
				p->size = size;
			}
			return p + 4; /* skip header */
		}
	}
	
	return NULL;
}
