#ifndef _TERMIOS_H_
#define _TERMIOS_H_

#include <types.h>

extern int cfgetispeed(struct termios *__termios_p);
extern int cfgetospeed(struct termios *__termios_p);
extern int cfsetispeed(struct termios *__termios_p, int __speed);
extern int cfsetospeed(struct termios *__termios_p, int __speed);

extern void cfmakeraw(struct termios *__t);

extern int tcsetattr(int __fd, int __opt, struct termios *__termios_p);
extern int tcgetattr(int __fildes, struct termios *__termios_p);
extern int tcdrain(int __fildes);
extern int tcflow(int __fildes, int __action);
extern int tcflush(int __fildes, int __queue_selector);
extern int tcsendbreak(int __fildes, int __duration);
extern int tcgetpgrp(int __fildes);
extern int tcsetpgrp(int __fildes, int __pgrp_id);

#endif /* _TERMIOS_H_ */
