; PedroM - Operating System for Ti-89/Ti-92+/V200.
; Copyright (C) 2003 PpHd
; 
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
; 
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
; 
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

; Strings

 include "const.h"

 data
STRINGS:

Pedrom_str		dc.b	"PedroM v"
			dc.l	PEDROM_STR_VERSION
			dc.b	" beta",0
Author_str		dc.b	10,169," 2003 PpHd / Time To Team",10,0

HeapCorrupted_str	dc.b	"Corrupted Heap",0
InitError_str		dC.b	"Error when booting system",0
Boot_str		dc.b	"BOOT code missing",0
OSTooBig_str		dc.b	"OS too huge!",0
TIBInstallError_str	dc.b	"INSTALL FAILED.",0
WrongCalc_str		dc.b	"WRONG CALCULATOR",0

;FKeyFormat_str		dc.b	"fkey%d",0
;APD_str			dc.b	"apd",0

ST_busy_str		dc.b	"BUSY",0
ST_pause_str		dc.b	"STOP",0
ST_batt_str		dc.b	"BATT",0
ST_none_str		dc.b	"           ",0
ST_2nd_str		dc.b	" 2ND   ",0
ST_shift_str		dc.b	"SHIFT ",0
ST_diamond_str		dc.b	" 3RD   ",0
ST_alpha_str		dc.b	"ALPHA",0	
ST_alphaLock_str	dc.b	"ALOCK",0
ST_SalphaLock_str	dc.b	"SALCK",0

ProductID_str		dc.b	"%02lX-%lX-%lX-%lX",0
HexFormat_str		dc.b	"%06lX: %02X %02X %02X %02X %02X %02X %02X %02X",10,0
ByteFormat_str		dc.b	"%02X ",0
;Dumping_str		dc.b	"Dumping...",10,0

	; LN / EXP / SIN / COS/ TAN / ASIN / ACOS/ATAN / SQRT / INTEGRAL / DERIVATE / Sigma / -1 / ANS
Ln_XRstr	dc.b	"ln(",0
Exp_XRstr	dc.b	"exp(",0
Sin_XRstr	dc.b	"sin(",0
Cos_XRstr	dc.b	"cos(",0
Tan_XRstr	dc.b	"tan(",0
ASin_XRstr	dc.b	"sin",180,"(",0
ACos_XRstr	dc.b	"cos",180,"(",0
ATan_XRstr	dc.b	"tan",180,"(",0
Sqrt_XRstr	dc.b	168,"(",0
Int_XRstr	dc.b	189,"(",0
Der_XRstr	dc.b	188,"(",0
Sigma_XRstr	dc.b	142,"(",0
Inv_XRstr	dc.b	"^-1",0
Ans_XRstr	dc.b	"ans(1)",0


StrError_msg_str:
	dc.b	"undefined errno value",0
	dc.b	"no error",0
	dc.b	"no such file entry",0
	dc.b	"I/O error",0
	dc.b	"not a serial device",0
	dc.b	"out of memory",0
	dc.b	"permission denied",0
	dc.b	"block device required",0
	dc.b	"no such device",0
	dc.b	"invalid argument",0
	dc.b	"file table is full",0
	dc.b	"device directory is full",0
	dc.b	"no space left on device",0
	dc.b	"no more allocation blocks",0
	dc.b	"no more data blocks on device",0
	dc.b	"file is open",0
	dc.b	"no RAM space configured",0
	dc.b	"no heap space configured",0
	dc.b	"seek can't extend read only file",0
	dc.b	"bad file descriptor - file not open",0
	dc.b	"invalid signal number",0
	dc.b	"argument out of range",0
	dc.b	"result out of range",0

; Vti version number
		EVEN
ReleaseVersion:	dc.l	PEDROM_STR_VERSION
		dc.b	0
ReleaseDate:	dc.b	"20/11/2003",0

	ifd	PRINTF_PACKET_DIALOG
DebugX_str		dc.b	"Send: %04X %04X  ",0
DebugY_str		dc.b	"Recv: %04X %04X  ",0
	endif
	EVEN
